///home/berryj/link/bin/genMethods "-t" "Testobj*" "-h" "SortedArray" "-r" "Array<Testobj*>" "-I" "LINK/basic/SortedArray.h" "-I" "LINK/userobj/Testobj.h" "-d" "userobj" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SortedArray.h>

#include <LINK/userobj/Testobj.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ArrayWrapper.h>


typedef Testobj* _Testobj_;
typedef SortedArray<Testobj* > _SortedArray_Testobj__;
static SortedArray<Testobj* > s__SortedArray_Testobj__;

#define _SortedArray_Testobj__DATA(x) ((SortedArray<Testobj* >*) (EXTDATA(x)))
#define _SortedArray_Testobj__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedArray<Testobj* > >::type))
#define _SortedArray_Testobj__ISNT_DATA(x) (!_SortedArray_Testobj__IS_DATA(x))

#define _SortedArray_Testobj__CXX_DATA(x) (*(SortedArray<Testobj* >*) (EXTDATA(VAL(x))))
#define _SortedArray_Testobj__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<SortedArray<Testobj* > >::type))
#define _SortedArray_Testobj__CXX_ISNT_DATA(x) (!_SortedArray_Testobj__CXX_IS_DATA(x))


PRIMITIVE STk_init__SortedArray_Testobj__()
{
	Wrapper<_SortedArray_Testobj__>::type = STk_new_CXXwrapper_id(
			Wrapper<_SortedArray_Testobj__>::name, 
			Wrapper<Array<Testobj*> >::name,
			(void (*)(SCM x, SCM port, int mode))
			ArrayWrapper<_Testobj_>::displayTypedArray,
			(void (*)(SCM x))ArrayWrapper<_Testobj_>::markTypedArray,
			(void (*)(SCM x))ArrayWrapper<_Testobj_>::freeTypedArray);
	Tcl_InitHashTable(&Register<_SortedArray_Testobj__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_SortedArray_Testobj__Methods(void);

PRIMITIVE STk_init_methods__SortedArray_Testobj__()
{
	genExtra_SortedArray_Testobj__Methods();
	return UNDEFINED;
}
